package service

import (
	"fmt"
	"iot_manager_service/app/dao"
	"iot_manager_service/app/utils"
	"strconv"
	"time"
)

// 操作记录服务
var OperationHisService = new(operationHisService)

type operationHisService struct{}

func (s *operationHisService) Save(handleType, handleModuleType int, handleContent string) {
	operation := dao.OperationHis{
		OperationType: handleType,
		ModuleType:    handleModuleType,
		HandleContent: handleContent,
		HandleUserId:  "TODO", //todo 使用登录态
		HandleTime:    time.Now(),
		TenantId:      "000000", //todo 使用登录态
	}
	err := operation.Create()
	if err != nil {
		fmt.Printf("Operation save err =%v \n", err)
	}
}

func (s *operationHisService) List(handleContent, operationType, moduleType string, current,
	size int) ([]dao.OperationHis, *utils.Errors) {
	his := dao.OperationHis{
		HandleContent: handleContent,
	}
	if operationType != "" {
		operation, err := strconv.Atoi(operationType)
		if err != nil {
			return nil, utils.FailResponse(err.Error(), nil)
		}
		his.OperationType = operation
	}
	if moduleType != "" {
		module, err := strconv.Atoi(moduleType)
		if err != nil {
			return nil, utils.FailResponse(err.Error(), nil)
		}
		his.ModuleType = module
	}
	list, err := his.GetHistories(current, size)
	if err != nil {
		return nil, utils.FailResponse(err.Error(), nil)
	}
	return list, nil
}
